<?php
@include("geoip.inc");

class login_activity extends rcube_plugin{
public $ip;
public $hostname;
public $flags_dir;
public $local_image_path;
public $isLocal;
public $location;
public $send_mail;
public $send_to;

//array of rules for local connections
public $RU_Local;


function init(){
	$this->add_hook('template_object_loginactivity', array($this, 'print_login_info'));
	$this->add_hook('login_after', array($this, 'rotate_old_times'));
	$this->add_hook('login_after', array($this, 'log_to_sysadmin_db'));
	$this->register_action('plugin.login_activity', array($this, 'show_details'));
	$this->load_config('config.inc.php');
	$this->load_config('sysadmin_db.inc.php');
	$this->include_stylesheet("login_activity.css");
	
   $rcmail = rcmail::get_instance();
	$this->RU_Local = $rcmail->config->get("RU_Local");
	$this->flags_dir = $rcmail->config->get('flags_dir');
	$this->local_image_path = $rcmail->config->get("local_image_path");
	$this->send_mail = $rcmail->config->get("send_mail");
	$this->send_to = $rcmail->config->get("send_to");
        $user_id = ($rcmail->user->data['user_id']);
        $hostname = ($rcmail->user->data['mail_host']);
	$this->send_to = str_replace("HOSTNAME",$hostname,$this->send_to);
}

function log_to_sysadmin_db(){
	$rcmail = rcmail::get_instance();	
	$hostname = $rcmail->user->data['mail_host'];	
	$user_id = $rcmail->user->data['user_id'];	
	$username = $rcmail->user->data['username'];	
	
	
	$current_ip = $_SERVER['REMOTE_ADDR'];

	$rcidentity_array = ($rcmail->user->get_identity());
	$rcidentity = $rcidentity_array['email'];

	$gi = geoip_open("/usr/local/share/GeoIP/GeoIP.dat",GEOIP_STANDARD);
	$code = geoip_country_code_by_addr($gi,$current_ip);	
	
	#if RU_Local, we'll just call it US
	if (strcmp($ip,"") == 0){$code="US";}
	geoip_close($gi);
	
	$dsn = $rcmail->config->get("sysadmin_dsn");

	#open our sysadmin db (we have to change back to normal roundcube db later)
	$database = new rcube_mdb2($dsn,'',FALSE);
	$database->db_connect('w');
	
	#$mysql_access = mysql_connect($host,$user,$pass);
	#mysql_select_db($db,$mysql_access);


	$query = "INSERT INTO log VALUES('$user_id','$hostname','$username','$rcidentity','$current_ip','$code',NULL)";
#	$res = mysql_query($query);
	$res = $database->query($query);
	
	#reset connection back normal roundcube db	
	$rcube_db =$rcmail->config->get("db_dsnw");
	$database_log = new rcube_mdb2($rcube_db,'',FALSE);
	$database_log->db_connect('w');
}

function get_flag_path($ip){
	if (strcmp($ip,"") == 0){return "$this->flags_dir/blank.gif";}
	$gi = geoip_open("/usr/local/share/GeoIP/GeoIP.dat",GEOIP_STANDARD);
	$code = strtolower(geoip_country_code_by_addr($gi,$ip));	
	geoip_close($gi);
	$path = "$this->flags_dir/$code.gif";
	return $path;
}

function show_details(){
	$rcmail = rcmail::get_instance();
	$rcmail->output->set_pagetitle("Login History Details");
	$rcmail->output->add_handlers(array('loginactivitycontent' => array($this,'content')));	
	$rcmail->output->send('loginactivity');
}
#this is obsoleted by check_any_change()
function check_moved_recently(){
#this function checks if the user has logged in from 2 different countries within $move_time. If so, thats pretty suspicious
	
	$rcmail = rcmail::get_instance();
        $user_id = ($rcmail->user->data['user_id']);
        $last_ip = ($rcmail->user->data['last_ip1']);
	$older_ip = ($rcmail->user->data['last_ip2']);
	$last_login = ($rcmail->user->data['last_login']);
	$older_login = ($rcmail->user->data['last_login2']);

	$difference = $last_login - $older_login;
	#if last two logins were more than move_time apart...
	if ($difference < $this->move_time){
		$gi = geoip_open("/usr/local/share/GeoIP/GeoIP.dat",GEOIP_STANDARD);
		$last_code = geoip_country_code_by_addr($gi,$last_ip);	
		$older_code = geoip_country_code_by_addr($gi,$older_ip);	
		geoip_close($gi);

		#if last two logins were from different countries...			
		if (strcmp($older_code,$last_code) != 0){
			$move_time_in_hours = ($this->move_time *(1/1000)) * (1/60) * (1/60);	
			$warnMessage= "<b>WARNING!</b> Your account has been accessed from two different countries in the last $move_time_in_hours hours. Your account may be compromised. <a href='http://roundcube-test/?_task=dummy&_action=plugin.login_activity'>Click Here</a> for more info.";
			$out .= "<script type=\"text/javascript\">$(document).ready(function() {
		
		$.jnotifica(\"$warnMessage\", {
		position : 'bottom',
		classes : 'login_bad',
		background : 'orange',
		timeout: 9999999999
	    });
	});</script>";
		self::mail_warning();
		}
	}
	return $out;

}


function check_any_change(){
//if any of our stored logins is different than our current location, show a warning
	$isBad=false;
	$badLocations=array();
	
	$rcmail = rcmail::get_instance();
        $user_id = ($rcmail->user->data['user_id']);

	
 	$lookup= self::get_login_info($rcmail->user->data['last_ip1']);
        $last_location = $lookup['Location'];
        if ($lookup['isLocal']){
		$oldPlace ="United States"; 
	}else{
		$oldPlace = $lookup['Location'];
	}

	for($index=2; $index <= 5; $index++){
		$last_ip = $rcmail->user->data["last_ip$index"];
	
		#if any of the logins is null, they haven't logged in 5 times yet
		#thats not enough the establish a pattern, don't bother warning	
		if ($last_ip==NULL){
			$isBad=false;
			return;
		}
		$lookup= self::get_login_info($rcmail->user->data["last_ip$index"]);
		
		if ($lookup['isLocal']){
			$toCompare = "United States";
		}else{
			$toCompare = $lookup['Location'];
		}
		if (strcmp($toCompare,$oldPlace)!=0){ 
			$isBad = true;
			if (!in_array($toCompare,$badLocations)){
				$badLocations[] = $toCompare;
			}	
		}
	}

	if ($isBad){
		$all_bad_locations="";
		$count = count($badLocations);
		foreach($badLocations as $index =>$loc){
			if($index < $count-1){
				$all_bad_locations .= "$loc and "; 
			}else{
				$all_bad_locations .= "$loc"; 
			}
		}
		$warnMessage= "You've recently logged in from $all_bad_locations, which seems inconsistent from your regular usage. Your account may be compromised. <a href=\'?_task=dummy&_action=plugin.login_activity'>Click Here</a> for more info.";
	

         $out .= "<script type=\"text/javascript\">$(document).ready(function() {
	
		var stack_bottomright = {\"dir1\": \"up\", \"dir2\": \"left\", \"firstpos1\": 15, \"firstpos2\": 15};

		$.pnotify({
				pnotify_title: 'Warning',
               		 	pnotify_text: \"$warnMessage\",
				pnotify_addclass: \"stack-bottomright\",
				pnotify_stack: stack_bottomright,
				pnotify_type: 'error',
				pnotify_animation: 'slide'

                });
                });
     </script>";


		self::mail_warning($all_bad_locations);
	}
	return $out;


}

function get_login_info($ip){
	$RU_Local=$this->RU_Local;
	if (strcmp($ip,"N/A")==0){
		return array("Location"=>"","isLocal"=>false);
	}
         //get country name, if connection is from Rutgers internal network returns ""
         #$location = apache_note("GEOIP_COUNTRY_NAME");
         #$double_check = apache_note("GEOIP_COUNTRY_NAME");
        $gi = geoip_open("/usr/local/share/GeoIP/GeoIP.dat",GEOIP_STANDARD);
	$location = geoip_country_name_by_addr($gi,$ip);
	$double_check = geoip_country_name_by_addr($gi,$ip);
	
	/* there is a bug in the api, occasionally we get bogus results
         * so we check twice. If we get different results, one of them must be bad, so check a third time
	 * The bug is very intermittent, so if it happened once already, we can assume it won't happen again on the third try
	 * (as per richton)
	 */
	if ($location != $double_check){
	        $location_new = geoip_country_name_by_addr($gi,$ip);
		log_lookup_bug($location,$double_check,$location_new,$ip);
	}
geoip_close($gi);

         $isLocal=false;
         //Check if connection is from Rutgers local stuff
         //if it is, replace country name with something sane
         foreach($RU_Local as $row => $rule){
                 if( $rule["Type"] == "ip"){
                         if (preg_match($rule['Pattern'] ,$ip)){
                                 $location=$rule;
                                 $isLocal=true;
                         }
                 }else{
                         if (preg_match($rule['Pattern'],$this->hostname)){
                                 $location=$rule;
                                 $isLocal=true;
                         }

                 }
         }
	return array("Location"=>$location,"isLocal"=>$isLocal);
}

function mail_warning($all_bad_locations){
	#if the config file option is set to false, don't send mail
	if (! $this->send_mail){
		return;
	}

	#only send 1 email per session
	if (empty($_SESSION['mailed_warning'])){
		$_SESSION['mailed_warning']='True';
	}else{
		return;
	}



	$rcmail = rcmail::get_instance();
	$user_id = ($rcmail->user->data['user_id']);
	$username = ($rcmail->user->data['username']);
	$mailhost= ($rcmail->user->data['mail_host']);
		openlog("GeoIP",LOG_PID);
		syslog(LOG_WARNING,"$username@$mailhost recently logged in from $all_bad_locations"); 
		closelog();



	$message = "Roundcube automated warning:\n\n";
	$message .= "$username@$mailhost may have been compromised.\n\nRecent History:\n\n";
	$message .="IP\t\t\tLocation\t\tDate/Time\n";

	for($index=1; $index <= 5; $index++){
		$ip = ($rcmail->user->data["last_ip$index"]);
		if ($ip == NULL){
			return;	
		}
		$message .= "$ip\t\t";

		$lookup= self::get_login_info($ip);
		$location = $lookup['Location'];
		$isLocal = $lookup['isLocal'];
		if ($isLocal){
			$place = $location['Comment'];
		}else{
			$place = $location;
		}
		$message .= "$place\t\t";
		if ($index==1){
			$date=$rcmail->user->data["last_login"];	
			$message .= "$date\n";
		}else{
			$date=$rcmail->user->data["last_login$index"];	
			$message .= "$date\n";
		}	
	}	

	
	mail("jarek@nbcs.rutgers.edu","Roundcube: Account \"$username@$mailhost\" Compromised",$message);


}

function content($attrib)
    {
      	$rcmail = rcmail::get_instance();
	$user_id = ($rcmail->user->data['user_id']);

	$out .= "<b><font size=+1>Your Activity</b></font><br>\n";
	$out .= "<p>This feature provides information about your webmail login activity, alerting you to suspicious access. ";
	$out .= "<br><br>If any of the times or places seem incorrect, your account may have been accessed by an unauthorized person, and you should contact the Help Desk immediately. ";
	$out .= "<a href='http://css.rutgers.edu/webmail/faq' target='_blank'>Learn more</a></p>\n";
	$out .= "<center>";
	$out .= "<table class='login_history' width='97%' align='center' border='0' cellpadding='8' cellspacing='0'>\n";
	$out .= "<tr>\n";
	$out .= "<td bgcolor='#D30f33'><b>IP</b></td>\n";
	$out .= "<td bgcolor='#d30f33'><b>Location</b></td>\n";
	$out .= "<td bgcolor='#d30f33'><b>Date/Time</b></td>\n";
	

   $this->print_login_info ($hurrr);

   $out .= "<tr><td>" . $this->ip . "</td><td><img src=\"" . ($this->isLocal
            ? $this->local_image_path . "/" . $this->location['Image'] . "\" /> " . $this->location['Comment'] . "</td>"
            : $this->get_flag_path($this->ip) . "\" />" . $this->location . "</td>") . "<td>Current Logon</td></tr>";
	
	for($index=1; $index <= 5; $index++){
		$out .= "<tr>";
		$ip = ($rcmail->user->data["last_ip$index"]);
		if ($ip == NULL){
			continue;	
		}
		$out .= "<td>$ip</td>";

		$lookup= self::get_login_info($ip);
		$location = $lookup['Location'];
		$isLocal = $lookup['isLocal'];
		if ($isLocal){
			$place = $location['Comment'];
			$flag=$this->local_image_path . "/" . $location['Image'];
			$out .= "<td><img src=\"$flag\" /> $place</td>";
		}else{
			$flag = self::get_flag_path($rcmail->user->data["last_ip$index"]);
			$out .= "<td><img src=\"$flag\" /> $location</td>";
		}
		if ($index==1){
			$date = ($rcmail->user->data['last_login']);
			$out .= "<td>$date</td>";
		}else{
			$date = ($rcmail->user->data["last_login$index"]);
			$out .= "<td>$date</td>";
		}	
	
		//if $isLocal=true, $location stores Pattern,Type,Description,Link,Image, and Comment
		//otherwise, its just a country name

		$out .= "</tr>\n";

	}
	
	
	$out .= "</table>\n";
	$out .= "</center>\n";
	$out .= "<br>\n<a href='?_task=mail' >Back</a>";
      	return $out;
    }


function log_lookup_bug($location1, $location2,$location_final,$ip){
	$message = "GEOIP lookup error: $ip resolved to $location1 and then $location2. On the third try, it resolved to $location_final";	
	openlog("mail",LOG_PID | LOG_PERROR);
	syslog(LOG_ERR,$message);
	mail("root@jla.rutgers.edu,oss@oss.rutgers.edu","GeoIp Lookup Error",$message);
}

function print_login_info($args){
	$rcmail = rcmail::get_instance();
	if( ! isset($rcmail->user->data['user_id'])){
		return $args;
	}
	$this->ip = $_SERVER['REMOTE_ADDR'];
	@ $this->hostname = $_SERVER['REMOTE_HOST'];
	$lookup=self::get_login_info($this->ip);
	$this->isLocal=$lookup['isLocal'];
	$this->location = $lookup['Location'];
	if (empty($_SESSION['geoip'])){
		$_SESSION['geoip']='True';
		self::save_login_ip($this->ip);
	}
	#these are obseleted by check_any_change
	#$args['content'] .= self::check_suspicious_activity();
	#$args['content'] .= self::check_moved_recently();

	$args['content'] .= self::check_any_change();
	//$args['content'] .= "<style type=\"text/css\">#login_time_foot a:hover { color:red; text-decoration:underline }</style>";
   $args['content'] .= "\n<div id='login_time'>\n";
	$args['content'] .= "\n<div style='padding: 5px; font-size:8pt' class='ui-widget-header ui-corner-top'>Account Activity</div>";
   $args['content'] .= "<div style='border-left: 1px solid #999; border-right: 1px solid #999; padding:5px; background-color:#F9F9F9;";
   $args['content'] .= "font-size:8pt'><b>Current Login:</b><table>";
	 //if $isLocal=true, $location stores Pattern,Type,Description,Link,Image, and Comment
	 //otherwise, its just a country name
	if ( $this->isLocal){
			 $args['content'] .=  "<tr><td style='padding:10px;' width='24'><img src=\"";
          $args['content'] .=  $this->local_image_path ."/" . $this->location['Image'] . "\"/></td><td style='font-size:8pt'>";
			 $args['content'] .=  $this->ip . " (" . $this->location['Description'] . ")\n\n";
			 $args['content'] .=  "<br>" . $this->location['Comment'] . "</td></tr>";

		 }else{
			$flag = self::get_flag_path($rcmail->user->data['last_ip1']);
			$args['content'] .= "<tr><td style='padding:10px;' width='24'><img src=\"$flag\" /></td><td style='font-size:8pt'>";
			$args['content'] .=  $this->ip . "<br>" . $location . "</td></tr>";
		 }
	$args['content'] .=  "</table><hr size='1px' color='#999'>\n\n";
	$args['content'] .= self::get_old_login_ip() . "</div><div id='login_time_foot' class='ui-corner-bottom' style='background-color:#E9E6DC;";
   $args['content'] .= "border: 1px solid #999; padding:5px; font-size:8pt; text-align:center;'>";
	$args['content'] .= "\n<a href='?_task=dummy&_action=plugin.login_activity' style='text-decoration:none;color:#06C;'>Details</a> | ";
	$args['content'] .= "\n<a href='http://css.rutgers.edu/webmail/faq' style='text-decoration:none;color:#06C;' target='_blank'> FAQ </a>";
	$args['content'] .=  "</div></div>\n";
	return $args;
}

 function save_login_ip($ip){
	$rcmail = rcmail::get_instance();
	$user_id = ($rcmail->user->data['user_id']);
	#whatever is in the current_ip field from last time is now our old ip
	$old_login = ($rcmail->user->data['current_ip']);
	
	$query = "UPDATE users SET last_ip1='$old_login' WHERE user_id='$user_id'";
	$res = mysql_query($query);
	
	$query = "UPDATE users SET current_ip='$ip' WHERE user_id='$user_id'";
	$res = mysql_query($query);
 }

function rotate_old_ips(){
	$rcmail = rcmail::get_instance();
	$user_id = ($rcmail->user->data['user_id']);
	for($index=5; $index > 1; $index--){
		$one_newer = $index-1;
		$newer_login=$rcmail->user->data["last_ip$one_newer"];
		
		$query = "UPDATE users SET last_ip$index='$newer_login' WHERE user_id='$user_id'";
		$res = mysql_query($query);
	}

}

function rotate_old_times(){
	self::rotate_old_ips();
	$rcmail = rcmail::get_instance();
	$user_id = ($rcmail->user->data['user_id']);
	for($index=5; $index > 2; $index--){
		$one_newer = $index-1;
		$newer_login=$rcmail->user->data["last_login$one_newer"];
		$query = "UPDATE users SET last_login$index='$newer_login' WHERE user_id='$user_id'";
		$res = mysql_query($query);
	}
	#the first/current one is called last_login, not last_login1 (for compatability), so its a special case
		$last_login = $rcmail->user->data['last_login'];
		$query = "UPDATE users SET last_login2='$last_login' WHERE user_id='$user_id'";
		$res = mysql_query($query);
}


function get_old_login_ip(){
	@ $args['content'] .=  "<b>Previous Login:</b>\n<br><table>\n";
 	$rcmail = rcmail::get_instance();
	$user_id = ($rcmail->user->data['user_id']);
	if ($rcmail->user->data['last_ip1'] == NULL){
		 $args['content'] .=  "</table>No previous login detected.\n<br>";
	}else{
		$lookup= self::get_login_info($rcmail->user->data['last_ip1']);
		$location = $lookup['Location'];
		$isLocal = $lookup['isLocal'];
		//if $isLocal=true, $location stores Pattern,Type,Description,Link,Image, and Comment
		 //otherwise, its just a country name
		if ( $isLocal ){
			  $args['content'] .=  "<tr><td style='padding:10px;' width='24'><img src=\"";
           $args['content'] .=  $this->local_image_path ."/" . $location['Image'] . "\"/></td><td style='font-size:8pt'>";
			  $args['content'] .=  $rcmail->user->data['last_ip1'] . " (" . $location['Description'] . ")\n<br>\n";
			  $args['content'] .=  $location['Comment'] . "</td></tr></table>";
	 
		  }else{
			$flag = self::get_flag_path($rcmail->user->data['last_ip1']);
			$args['content'] .= "<tr><td style='padding:10px;' width='24'><img src=\"$flag\" /></td><td style='font-size:8pt'>";
			$args['content'] .=  $rcmail->user->data['last_ip1'] . " <br>" . $location . "</td></tr></table>";
		  }
		
	}
	
	return $args['content'];
}

}
?>
