<?php
/* Rutgers Status Plugin
 *
 * Plugin to display Rutgers status info.
 *
 * @version 0.1
 * @author Russell Frank
 */

function secstostr($secs)
{
   $weeks = floor ($secs/604800);
   $secs = $secs % 604800;
   $days = floor ($secs/86400);
   $secs = $secs % 86400;
   $hours = floor ($secs/3600);
   $secs = $secs % 3600;
   $minutes = floor ($secs/60);
   $secs = $secs % 60;
   //$r = sprintf("%02d weeks %02d days %02d hours %02d minutes %02d seconds", $weeks, $days, $hours, $minutes, $secs);
   if ($weeks > 0)
      if ($days !=0)
         return "$weeks weeks and $days days ago";
      else
         return "$weeks weeks ago";
   else if ($days > 0)
      if ($hours != 0)
         return "$days days and $hours hours ago";
      else
         return "$days days ago";
   else if ($hours > 0)
      if ($minutes != 0)
         return "$hours hours and $minutes minutes ago";
      else
         return "$hours hours ago";
   else
      return "$minutes minutes and $seconds seconds ago";
}

function secstostr_full($secs)
{
   $weeks = floor ($secs/604800);
   $secs = $secs % 604800;
   $days = floor ($secs/86400);
   $secs = $secs % 86400;
   $hours = floor ($secs/3600);
   $secs = $secs % 3600;
   $minutes = floor ($secs/60);
   $secs = $secs % 60;
   $r = '';
   if ($weeks > 0)
   {
      $na = 1;
      $r .= "$weeks week";
      if ($weeks != 1)
         $r .= "s";
   }
   if ($days > 0)
   {
      if ($na)
         $r .= ", ";
      $na = 1;
      $r .= "$days day";
      if ($days != 1)
         $r .= "s";
   }
   if ($hours > 0)
   {
      if ($na)
         $r .= ", ";
      $na = 1;
      $r .= "$hours hour";
      if ($hours != 1)
         $r .= "s";
   }
   if ($minutes > 0)
   {
      if ($na)
         $r .= ", ";
      $na = 1;
      $r .= "$minutes minute";
      if ($hours != 1)
         $r .= "s";
   }
   if ($secs > 0)
   {
      if ($na)
         $r .= " and ";
      $na = 1;
      $r .= "$secs second";
      if ($secs != 1)
         $r .= "s";
   }
   return $r .= " ago";
}

class rutgers_status extends rcube_plugin
{
   public $task = 'mail|addressbook|settings|dummy|help';

   function init()
   {
      //$this->load_config ();
      $this->register_action('plugin.rutgers_status.update', array($this, "get_info"));
      $this->include_script('rutgers_status.js');
      $this->include_script('jquery.jnotifica.min.js');
      //$this->add_texts('localization/', true);
      //$this->add_hook('user_preferences', array($this, 'add_prefs'));
      //$this->add_hook('list_prefs_sections', array($this, 'add_prefs_section'));
      $this->add_hook('template_object_rustatus', array($this, 'output_status'));
      //$this->add_hook('save_preferences', array($this, 'write_prefs'));
      $this->include_stylesheet("rutgers_status.css");
   }
/*
   function write_prefs ($args)
   {
      console (print_r($args, true));
      console (print_r($_POST, true));
      if ($args['section'] == 'rutgers_status')
      {
         $args['prefs']['russ_update'] = get_input_value('rutgers_status_update', RCUBE_INPUT_POST);
         $args['prefs']['russ_popout'] = get_input_value('rutgers_status_popout', RCUBE_INPUT_POST);
      }
      return $args;
   }

   function add_prefs ($args)
   {
      $rs_texts = $GLOBALS["rs_text_settings"];
      if ($args['section'] == 'rutgers_status')
      {
         $args['blocks']['main']['name'] = "Rutgers Status Preferences";
         $args['blocks']['main']['options']['rutgers_status']['content'] = $this->gettext('settings');
      }
      return $args;
   }

   function add_prefs_section ($args)
   {
      $temp['rutgers_status']['id'] = 'rutgers_status';
      $temp['rutgers_status']['section'] = 'Rutgers Status';
      $args['list'] += $temp;
      return $args;
   }
*/
   function output_status($args)
   { 
      $args['content'] .= "<script type=\"text/javascript\">$(document).ready(function(){update_status();});".
                          "setInterval(\"update_status()\", 60*1000);</script><div id=\"rustatus_notification_area\"></div>";
      return $args;
   }

   function get_info ()
   {
      $info = array();
      if ($data = file_get_contents ("http://campusstatus.rutgers.edu/status.xml"))
      {
         $p = xml_parser_create();
         xml_parse_into_struct ($p, $data, $vals, $index);
         xml_parser_free ($p);
         foreach ($vals as $tags)
            $info[$tags["tag"]] = @$tags["value"];
      }
      else
      {
         $info['STATUS'] = 4;
         $info['MESSAGE'] = "Error: Could not get campus status information!";
      }
      $rcmail = rcmail::get_instance();
      //$info['LASTUPDATED'] = "3/16/2010 18:25:52";
      //$info['STATUS'] = "2"; $info['MESSAGE'] = "Rutgers University's New Brunswick & Piscataway campuses will not be open on Thursday, February 25th or Friday, February 26th due to a forecast of 18 feet of snow.  All offices are closed and all classes will be canceled for these two days.";
      if (!(!isset($_SESSION['russ_lastup']) || ($info['LASTUPDATED']!=$_SESSION['russ_lastup'])))
         $info['NOCHANGE'] = "true";
      $since = strtotime("now") - strtotime($info['LASTUPDATED']);
      $info['SINCE'] = secstostr($since);
      $info['FULLSINCE'] = secstostr($since);
      $rcmail->output->command('plugin.rutgers_status.update.response', $info);
      $_SESSION['russ_lastup'] = $info['LASTUPDATED'];
   }
}

?>
