rcmail.addEventListener('plugin.forward-post-callback', forward_post_callback);

$(document).ready(function(){$("#emailBox").keyup(validateEmail);});

function forward_post(disable_forward, remove_address) {
    
    if (!disable_forward && !remove_address && !validateEmail()) {
        return false;
    }

    var data;

    if (disable_forward) {
        
        data = 'disable=1';

        var ftype = $('#forwardType').serialize();
        if (ftype) {
            data += '&' + ftype;
        }

        var vac = $('#vacation').serialize();
        if (vac) {
            data += '&' + vac;
        }

        var vac_s = $('#newFormatVacation_S').serialize();
        if (vac_s) {
            data += '&' + vac_s;
        }

    }
    else if (remove_address) {
        data = $('#webtools-form').serialize();
        data += '&removeAddress=' + encodeURIComponent(remove_address);
    }
    else {
        data = $('#webtools-form').serialize();
    }

    rcmail.http_post('plugin.webtoolsforward-post', data);

    return true;
}

function forward_copycheck ()
{
   var state = $('#localCopy').attr('checked');
   var existingAddr_S = $('#existingAddr_S').attr('value');
   rcmail.http_post('plugin.webtoolsforward-post', { 'func':'localcopy', 'value':state, 'existingAddr_S':existingAddr_S });
}
        
function forward_post_callback(response) {
    
   if (response.func == 'localcopy')
   {
      alert (response.postvars);
      return;
   }

    if (response.update_content === 'yes') {
        
        // Fill in hidden input fields
        $('#temp_input').html(response.hidden_input);
        $('#address_list').html(response.addr_list);
        
        // Clear the text box and enable it
        $('#emailBox').val('');
        $('#emailBox').removeAttr('disabled');
        $('#emailBox').removeClass('ui-state-disabled');

        // Disable the save button
        $('#saveButton').attr('disabled', 'disabled');
        $('#saveButton').addClass('ui-state-disabled');
        
        // Hide the local copy checkbox if there are no exisitng addresses
        if (response.disabled === 'yes') {
            $('#checkboxArea').hide();
        }

    }

    $('#result').html(response.message);

}

//validation function
function validateEmail(){
    
    var email = $('#emailBox');
    var emailError = $('#emailError');

    //testing regular expression
    var a = email.val();
    var filter = /^[a-zA-Z0-9]+[a-zA-Z0-9_.-]+[a-zA-Z0-9_-]+@[a-zA-Z0-9]+[a-zA-Z0-9.-]+[a-zA-Z0-9]+.[a-z]{2,4}$/;

    //if it's valid email
    if(filter.test(a)) {
        email.removeClass('ui-state-error');
        emailError.text('');
        return true;
    }

    //if it's NOT valid
    else {
        email.addClass('ui-state-error');
        //emailError.text('Enter a valid e-mail address!');
        return false;
    }

}
