<?php

// Roundcube-style variables
$rcmail = rcmail::get_instance();

$USERNAME = $rcmail->config->get('USERNAME');
$HOME = $rcmail->config->get('HOME');
$RUNAS_CMD = $rcmail->config->get('RUNAS_CMD');
$MF = $rcmail->config->get('MF');

?>

<h2>Mail Forwarding</h2>

<?php

// Initialize variables
$oldForwardFileExist = FALSE;
$oldForwardFileConvert = FALSE;
$oldForwardFileResult = NULL;

$newForwardFileExist = FALSE;
$newForwardFileResult = NULL;
$newFormatVacation = NULL;

$newVacationFileResult = NULL;

$vacationExist = FALSE;
$localCopyChecked = NULL;
$localCopyPrior = 'off';
$hiddenInputStatic = '';
$hiddenInputTemp = '';
$result = NULL;
$type = NULL;

$existingAddressList = '';
$existingAddr_Arr = NULL;

$removeAllLink = '';

if (have_file('.forward', $result)) {
    $oldForwardFileExist = TRUE;
    $oldForwardFileResult = $result;
    $type = 'f';
}
elseif (have_file('.qmail', $result)) {
    $oldForwardFileExist = TRUE;
    $oldForwardFileResult = $result;
    $type = 'q';
}

// Do they have a mailfilter-vacation file?
if (have_file('Maildir/mailfilter-vacation', $result)) {
    $newVacationFileResult = $result;
    foreach ($newVacationFileResult as $line) {
        if (is_newFormatVacation($line, $_)) {
            $newFormatVacation_S = base64_encode(serialize($line));
            $hiddenInputStatic .= '<input type="hidden" name="newFormatVacation_S" id="newFormatVacation_S" value="' . $newFormatVacation_S . '" />';
            continue; 
        }
    }
    $hiddenInputTemp .= '<input type="hidden" name="newVacationFileExist" value="1" />';
}

//Do they have a mailfilter-forward file?
if (have_file('Maildir/mailfilter-forward', $result)) {
    $newForwardFileExist = TRUE;
    $newForwardFileResult = $result;
    foreach ($newForwardFileResult as $line) {
        if (is_newFormatLocalCopy($line)) {
            $localCopyChecked = '"checked"';
            $localCopyPrior = 'on';
        }
        if (is_newFormatAddress($line, $existingAddr_Arr)) {
            continue;
        }
        if (is_newFormatVacation($line, $_) && !isset($newFormatVacation_S)) {
            $newFormatVacation_S = base64_encode(serialize($line));
            $hiddenInputStatic .= '<input type="hidden" name="newFormatVacation_S" id="newFormatVacation_S" value="' . $newFormatVacation_S . '" />';
            continue;
        }
    } 
}

// Is the old forward file one we recognize (no weird procmail stuff, etc)
if ($oldForwardFileExist) {
    $oldForwardFileConvert = TRUE;
    switch ($type) {
        case 'q':
            $firstLine = TRUE;
            foreach ($oldForwardFileResult as $line) {
                if ($firstLine) {
                    $firstLine = FALSE;
                    if (preg_match("/^\s*$/", $line)) {
                        $oldForwardFileConvert = FALSE;
                        break;
                    }
                }
                if (is_blankline($line) || is_comment($line)) {
                    continue;
                }
                if (is_oldFormatVacation($line)) {
                    $vacationExist = TRUE;
                    continue;
                }
                if (is_oldFormatLocalCopy($line)) {
                    $localCopyChecked = '"checked"';
                    $localCopyPrior = 'on';
                    continue;
                }
                // Found something bizarre
                if (!is_oldFormatAddress($line, $existingAddr_Arr)) {
                    $oldForwardFileConvert = FALSE;
                    break;
                }
            }
            break;
        case 'f':
            foreach ($oldForwardFileResult as $line) {
                if (is_blankline($line) || is_comment_forward($line)) {
                    continue;
                }
                if (is_oldFormatVacation($line)) {
                    $vacationExist = TRUE;
                    continue;
                }
                if (is_oldFormatLocalCopy($line)) {
                    $localCopyChecked = '"checked"';
                    $localCopyPrior = 'on';
                    continue;
                }
                // Found something bizarre
                if (!is_oldFormatAddress_forward($line, $existingAddr_Arr)) {
                    $oldForwardFileConvert = FALSE;
                    break;
                }
            }
            break;
    }
}

// Save the old local copy preference
$hiddenInputTemp .= '<input type="hidden" id="localCopyPrior" name="localCopyPrior" value="'.$localCopyPrior.'" />';

// Are we converting?
if ($oldForwardFileConvert) {
    if ($vacationExist) {
        $hiddenInputTemp .= '<input type="hidden" name="vacation" value="1" />';
    }
    $hiddenInputTemp .= '<input type="hidden" name="forwardType" id="forwardType" value="'.$type.'" />';
}

if (is_array($existingAddr_Arr)) {

    $existingAddr_S = base64_encode(serialize($existingAddr_Arr));
    $hiddenInputTemp .= '<input type="hidden" name="existingAddr_S" value="'.$existingAddr_S.'" />';

    $existingAddressList = '<label style="display: block; margin-bottom: 10px;">Existing Addresses</label><ul>';

    foreach ($existingAddr_Arr as $address) {
        $existingAddressList .=
           '<li onclick="forward_post(false, \''.$address.'\'); return false;" title="Remove this address">'
                .$address.
           '</li>';
    }
    $existingAddressList .= '<li onclick="forward_post(true); return false;" title="Remove all addresses">Remove All</li></ul>';
}

?>

<style type="text/css">

    ul
    {
        list-style-type: none;
        padding: 0;
        margin: 0;
    }

    li
    {
        background-image: url('/skins/rutgers/images/remove.png');
        background-repeat: no-repeat;
        padding-left: 30px;
        margin: 5px 0;
        height: 25px;
        max-width: 20em;
        color: #0066CC;
        cursor: pointer;
    }

    #emailBox
    {
        height:40px;
        font-size:30px;
        margin-bottom: 5px;
    }

    #emailError
    {
        font-style: italic;
        color: #DC5757;
        margin-bottom: 5px;
    }

    #checkboxArea
    {
        margin-bottom: 5px;
    }

    #address_list
    {   
        margin-top: 20px;
    }

</style>

<script type="text/javascript" src="plugins/webtools/webtools/forward/forward_post.js"></script>

<script type="text/javascript">

    function emailbox_focus_action() {
        $('#saveButton').removeAttr('disabled');
        $('#saveButton').removeClass('ui-state-disabled');
    }

    function checkbox_click_action() {
        if ($('#emailBox').attr('disabled')) {
            $('#emailBox').removeAttr('disabled');
            $('#emailBox').removeClass('ui-state-disabled');
            $('#saveButton').attr('disabled', 'disabled');
            $('#saveButton').addClass('ui-state-disabled');
        }
        else {
            $('#emailBox').attr('disabled', 'disabled');
            $('#emailBox').addClass('ui-state-disabled');
            $('#saveButton').removeAttr('disabled');
            $('#saveButton').removeClass('ui-state-disabled');
        }
    }

</script>

<div id="result"></div>

<div id="webtools-innerbox" class="ui-widget ui-widget-content ui-corner-all">
    <form id="webtools-form" style="margin: auto;" onsubmit="forward_post(); return false;">
        <?=$hiddenInputStatic?>
        <div>
            <div style="display:block; padding-bottom:15px;">
               <input id="localCopy" type="checkbox" class="webtools-checkbox" name="localCopy" onclick="forward_copycheck();" <?=$localCopyChecked?> />
               <label for="localCopy">Copy forwarded messages to my local account</label>
            </div>
            <!--<input id="emailBox" class="ui-corner-all-4px" type="text" name="newAddress" value="" size="25" maxlength="129" onfocus="emailbox_focus_action();" />-->
            <input id="emailBox" class="ui-corner-all-4px" type="text" name="newAddress" value="" size="25" maxlength="129" />
            <div style='margin:5px; margin-right: 10px; width: 32px; height:32px; float:left'
                 class='ui-button ui-widget ui-state-default ui-corner-all'>
               <a href="#" onclick="forward_post();"><img src="plugins/webtools/webtools/forward/list-add.png"></a>
            </div>
        </div>
        <div id="emailError"></div>
        <!--<div id="checkboxArea" style="float: left; margin-right: 30px;">
            <input id="localCopy" type="checkbox" class="webtools-checkbox" name="localCopy" onclick="checkbox_click_action();" <?=$localCopyChecked?> />
        </div>-->
            <!--<button id="saveButton" type="submit" class="webtools-button ui-state-default ui-corner-all">Add</button>-->
        <div style="clear: both;"></div>
        <div id="temp_input">
            <?=$hiddenInputTemp?>
        </div>
        <div id="address_list">
            <?=$existingAddressList?>
        </div>
    </form>
</div>

<div id="webtools-instructions" class="webtools-accordion">
    <div>
        <h3><a id="instr-header" href="#">Help</a></h3>
        <div id="instr-content">
        </div>
    </div>
</div>
